--- debug.after.a	2015-11-23 02:46:18.607906000 +0100
+++ debug.after.b	2015-11-23 02:46:18.691904000 +0100
@@ -11265,11 +11265,11 @@
     key: 119
     entity: 572
     x: 312.5
     z: 856.5
     clearance: 0.8
-    flags: 21
+    flags: 5
     group: 572
     key: 120
     entity: 573
     x: 371.81391
     z: 791.29122
@@ -13943,14 +13943,14 @@
     clearance: 0.8
     flags: 21
     group: 3884
     key: 660
     entity: 3902
-    x: 316.62284
-    z: 860.62284
+    x: 313.54319
+    z: 857.6989
     clearance: 0.8
-    flags: 21
+    flags: 5
     group: 3902
     key: 661
     entity: 3903
     x: 483.4989
     z: 734.84961
@@ -26330,69 +26330,12 @@
     goal hw: 11.25
     goal hh: 16.25
     maxdist: 7
     pass class: 64
     notify: 3108
-    length: 82
+    length: 79
     ticket: 258066
-    x0: 473.64739
-    z0: 407.36998
-    clearance: 0.8
-    range: 8
-    type: 0
-    goal x: 475.5
-    goal z: 414.5
-    goal u x: 0
-    goal u z: 0
-    goal v x: 0
-    goal v z: 0
-    goal hw: 0
-    goal hh: 0
-    maxdist: 0
-    pass class: 4
-    avoid moving units: false
-    group: 4081
-    notify: 4081
-    ticket: 258067
-    x0: 539.5
-    z0: 51
-    clearance: 0.8
-    range: 8
-    type: 0
-    goal x: 534.5
-    goal z: 55.5
-    goal u x: 0
-    goal u z: 0
-    goal v x: 0
-    goal v z: 0
-    goal hw: 0
-    goal hh: 0
-    maxdist: 0
-    pass class: 4
-    avoid moving units: false
-    group: 4134
-    notify: 4134
-    ticket: 258068
-    x0: 559.125
-    z0: 51.5
-    clearance: 0.8
-    range: 8.91015
-    type: 0
-    goal x: 551.75
-    goal z: 56.5
-    goal u x: 0
-    goal u z: 0
-    goal v x: 0
-    goal v z: 0
-    goal hw: 0
-    goal hh: 0
-    maxdist: 0
-    pass class: 4
-    avoid moving units: false
-    group: 4298
-    notify: 4298
-    ticket: 258069
     x0: 623.38949
     z0: 592.61052
     clearance: 0.8
     range: 8
     type: 0
@@ -67571,12 +67514,12 @@
     owner: 7
     in world: 1
     flags: 1
     scripted visibility: 0
     key: 3902
-    x: 316.62284
-    z: 860.62284
+    x: 313.54319
+    z: 857.6989
     vision: 80
     visibilities: 10880
     size: 1
     retain in fog: 0
     owner: 7
@@ -85013,11 +84956,11 @@
     dirty visibility: 0
     dirty visibility: 0
     dirty visibility: 0
     dirty visibility: 0
     dirty visibility: 0
-    length: 287
+    length: 286
     modified entities: 2970
     modified entities: 2973
     modified entities: 3639
     modified entities: 3019
     modified entities: 2127
@@ -85086,11 +85029,10 @@
     modified entities: 3834
     modified entities: 3877
     modified entities: 3878
     modified entities: 3881
     modified entities: 3884
-    modified entities: 3902
     modified entities: 3916
     modified entities: 4030
     modified entities: 4080
     modified entities: 4081
     modified entities: 4101
@@ -200809,11 +200751,11 @@
     active: true
     x: 312.5
     z: 856.5
   Obstruction:
     active: true
-    moving: true
+    moving: false
     control group: 572
     control group 2: 0
     tag: 238
     flags: 5
     clearance: 0.8
@@ -200837,60 +200779,46 @@
     floating: false
     constructionprogress: 0
     turret parent: 0
   Selectable:
   UnitMotion:
-    state: 3
-    path state: 3
+    state: 0
+    path state: 0
     pass class: "default"
     ticket: 0
-    target entity: 7300
+    target entity: 7221
     target pos x: 0
     target pos y: 0
     target offset x: 0
     target offset y: 0
     target min range: 0
     target max range: 2.8
     speed: 8.5
-    moving: true
+    moving: false
     facePointAfterMove: true
     tries: 0
-    length: 5
-    waypoint x: 311.5
-    waypoint z: 962.5
-    waypoint x: 311.5
-    waypoint z: 924
-    waypoint x: 318.5
-    waypoint z: 897.75
-    waypoint x: 322
-    waypoint z: 883.625
-    waypoint x: 325.5
-    waypoint z: 869.5
-    length: 2
-    waypoint x: 325.5
-    waypoint z: 869.5
-    waypoint x: 317.78531
-    waypoint z: 859.46036
+    length: 0
+    length: 0
     length: 0
     expected path ticket: 0
     next step clean: true
     type: 3
-    goal x: 314.69867
-    goal z: 967.31849
-    goal u x: 0.20322
-    goal u z: -0.9793
-    goal v x: 0.9793
-    goal v z: 0.20322
-    goal hw: 3.78333
-    goal hh: 3.78333
+    goal x: 306.15998
+    goal z: 871.23163
+    goal u x: -0.7074
+    goal u z: -0.70743
+    goal v x: 0.70743
+    goal v z: -0.7074
+    goal hw: 13.78333
+    goal hh: 14.78333
     maxdist: 0
   Vision:
   VisualActor:
     r: 1
     g: 1
     b: 1
-    anim run threshold: 11.75
+    anim run threshold: 0
     anim name: "build"
     anim once: false
     anim speed: 1
     sound group: "resource/construction/con_wood.xml"
     anim desync: 0.05
@@ -200966,10 +200894,19 @@
     object: {
   "orderQueue": [
     {
       "type": "Repair",
       "data": {
+        "target": 7221,
+        "autocontinue": true,
+        "force": false,
+        "autoharvest": true
+      }
+    },
+    {
+      "type": "Repair",
+      "data": {
         "target": 7300,
         "autocontinue": true,
         "force": true
       }
     },
@@ -201103,13 +201040,14 @@
     }
   ],
   "order": {
     "type": "Repair",
     "data": {
-      "target": 7300,
+      "target": 7221,
       "autocontinue": true,
-      "force": true
+      "force": false,
+      "autoharvest": true
     }
   },
   "formationController": 0,
   "isGarrisoned": false,
   "isIdle": false,
@@ -201119,13 +201057,15 @@
     "x": 412.36712646484375,
     "z": 802.985595703125
   },
   "workOrders": [],
   "stance": "aggressive",
-  "fsmStateName": "INDIVIDUAL.REPAIR.APPROACHING",
+  "fsmStateName": "INDIVIDUAL.REPAIR.REPAIRING",
+  "timer": 82616,
   "losRangeQuery": 219,
-  "fsmReenter": false
+  "fsmReenter": false,
+  "repairTarget": 7221
 }
   Visibility:
     object: {
   "retainInFog": false,
   "alwaysVisible": false,
@@ -381951,88 +381891,78 @@
   Minimap:
     r: 235
     g: 120
     b: 20
     active: true
-    x: 316.62284
-    z: 860.62284
+    x: 313.54319
+    z: 857.6989
   Obstruction:
     active: true
-    moving: true
+    moving: false
     control group: 3902
     control group 2: 0
     tag: 1320
     flags: 5
     clearance: 0.8
   OverlayRenderer:
   Ownership:
     owner: 7
   Position:
     in world: true
-    x: 316.62284
+    x: 313.54319
     y: 0
-    z: 860.62284
+    z: 857.6989
     last x: 313.54319
     last y diff: 0
     last z: 857.6989
     territory: 7
     rot x: 0
-    rot y: 0.80578
+    rot y: -0.5545
     rot z: 0
     altitude: 0
     relative: true
     floating: false
     constructionprogress: 0
     turret parent: 0
   Selectable:
   UnitMotion:
-    state: 3
-    path state: 3
+    state: 0
+    path state: 0
     pass class: "default"
     ticket: 0
-    target entity: 7300
+    target entity: 7221
     target pos x: 0
     target pos y: 0
     target offset x: 0
     target offset y: 0
     target min range: 0
     target max range: 2.8
     speed: 8.5
-    moving: true
+    moving: false
     facePointAfterMove: true
     tries: 0
-    length: 5
-    waypoint x: 311.5
-    waypoint z: 962.5
-    waypoint x: 311.5
-    waypoint z: 924
-    waypoint x: 318.5
-    waypoint z: 897.75
-    waypoint x: 322
-    waypoint z: 883.625
-    waypoint x: 325.5
-    waypoint z: 869.5
+    length: 0
     length: 0
     length: 0
     expected path ticket: 0
     next step clean: true
     type: 3
-    goal x: 314.69867
-    goal z: 967.31849
-    goal u x: 0.20322
-    goal u z: -0.9793
-    goal v x: 0.9793
-    goal v z: 0.20322
-    goal hw: 3.78333
-    goal hh: 3.78333
+    goal x: 306.15998
+    goal z: 871.23163
+    goal u x: -0.7074
+    goal u z: -0.70743
+    goal v x: 0.70743
+    goal v z: -0.7074
+    goal hw: 13.78333
+    goal hh: 14.78333
     maxdist: 0
   Vision:
   VisualActor:
     r: 1
     g: 1
     b: 1
-    anim run threshold: 11.75
+    anim run threshold: 0
     anim name: "build"
     anim once: false
     anim speed: 1
     sound group: "resource/construction/con_wood.xml"
     anim desync: 0.05
@@ -382110,10 +382040,19 @@
     object: {
   "orderQueue": [
     {
       "type": "Repair",
       "data": {
+        "target": 7221,
+        "autocontinue": true,
+        "force": false,
+        "autoharvest": true
+      }
+    },
+    {
+      "type": "Repair",
+      "data": {
         "target": 7300,
         "autocontinue": true,
         "force": true
       }
     },
@@ -382247,25 +382186,28 @@
     }
   ],
   "order": {
     "type": "Repair",
     "data": {
-      "target": 7300,
+      "target": 7221,
       "autocontinue": true,
-      "force": true
+      "force": false,
+      "autoharvest": true
     }
   },
   "formationController": 0,
   "isGarrisoned": false,
   "isIdle": false,
   "lastFormationTemplate": "formations/null",
   "finishedOrder": false,
   "workOrders": [],
   "stance": "aggressive",
-  "fsmStateName": "INDIVIDUAL.REPAIR.APPROACHING",
+  "fsmStateName": "INDIVIDUAL.REPAIR.REPAIRING",
+  "timer": 82790,
   "losRangeQuery": 2137,
-  "fsmReenter": false
+  "fsmReenter": false,
+  "repairTarget": 7221
 }
   Visibility:
     object: {
   "retainInFog": false,
   "alwaysVisible": false,
@@ -391308,24 +391250,24 @@
     constructionprogress: 0
     turret parent: 0
   Selectable:
   UnitMotion:
     state: 3
-    path state: 5
+    path state: 3
     pass class: "default"
-    ticket: 258066
+    ticket: 0
     target entity: 7056
     target pos x: 0
     target pos y: 0
     target offset x: 0
     target offset y: 0
     target min range: 0
     target max range: 47.94248
     speed: 11
     moving: true
     facePointAfterMove: true
-    tries: 1
+    tries: 0
     length: 2
     waypoint x: 475.5
     waypoint z: 425.5
     waypoint x: 475.5
     waypoint z: 414.5
@@ -394221,28 +394163,30 @@
     constructionprogress: 0
     turret parent: 0
   Selectable:
   UnitMotion:
     state: 3
-    path state: 5
+    path state: 3
     pass class: "default"
-    ticket: 258067
+    ticket: 0
     target entity: 6012
     target pos x: 0
     target pos y: 0
     target offset x: 0
     target offset y: 0
     target min range: 0
     target max range: 2
     speed: 11
     moving: true
     facePointAfterMove: true
-    tries: 1
+    tries: 0
+    length: 1
+    waypoint x: 534.5
+    waypoint z: 55.5
     length: 1
     waypoint x: 534.5
     waypoint z: 55.5
-    length: 0
     length: 0
     expected path ticket: 0
     next step clean: true
     type: 3
     goal x: 525.24677
@@ -402082,32 +402026,34 @@
     constructionprogress: 0
     turret parent: 0
   Selectable:
   UnitMotion:
     state: 3
-    path state: 5
+    path state: 3
     pass class: "default"
-    ticket: 258068
+    ticket: 0
     target entity: 6012
     target pos x: 0
     target pos y: 0
     target offset x: 0
     target offset y: 0
     target min range: 0
     target max range: 2
     speed: 11
     moving: true
     facePointAfterMove: true
-    tries: 1
+    tries: 0
     length: 3
     waypoint x: 536.5
     waypoint z: 57.5
     waypoint x: 546
     waypoint z: 57.5
     waypoint x: 551.75
     waypoint z: 56.5
-    length: 0
+    length: 1
+    waypoint x: 551.75
+    waypoint z: 56.5
     length: 0
     expected path ticket: 0
     next step clean: true
     type: 3
     goal x: 525.24677
@@ -588086,18 +588032,20 @@
   "committed": true,
   "builders": [
     3006,
     2970,
     2973,
+    572,
     2971,
     2992,
     3639,
     3642,
     3643,
+    3902,
     3019
   ],
-  "buildMultiplier": 0.5172818579717863,
+  "buildMultiplier": 0.48705969722582815,
   "previewEntity": 7228,
   "finalTemplateName": "structures/spart_fortress",
   "owner": 7,
   "costs": {
     "food": 0,