Index: binaries/data/mods/public/simulation/templates/units/cart_cavalry_spearman_ital_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_cavalry_spearman_ital_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_cavalry_spearman_ital_b.xml	(copie de travail)
@@ -10,11 +10,12 @@
   <Identity>
     <Civ>cart</Civ>
     <SelectionGroupName>units/cart_cavalry_spearman_ital_b</SelectionGroupName>
     <GenericName>Italic Cavalry</GenericName>
     <SpecificName>Ḥayyāl Romaḥ Raḫūv</SpecificName>
-    <Classes datatype="tokens">Italian Mercenary</Classes>
+    <Classes datatype="tokens">Italian</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>The Italian allies of Carthage included the various Samnite tribes of the interior hill-country and Italiote Greek colonies along the Southern coast. They provided a much-needed and high-quality cavalry contingent for Hannibal's army.</History>
     <Icon>units/cart_cavalry_spearman.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_cavalry_spearman_ital_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_cavalry_swordsman_gaul_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_cavalry_swordsman_gaul_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_cavalry_swordsman_gaul_b.xml	(copie de travail)
@@ -9,11 +9,12 @@
   <Identity>
     <Civ>cart</Civ>
 	<SelectionGroupName>units/cart_cavalry_swordsman_gaul_b</SelectionGroupName>
     <GenericName>Gallic Mercenary Cavalry</GenericName>
 	<SpecificName>Ḥayyāl Ḥerev Raḫūv</SpecificName>
-    <Classes datatype="tokens">Celt Mercenary</Classes>
+    <Classes datatype="tokens">Celt</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>Like a sword, a horse was a sign of nobility and as a result the Celtic cavalry was often better equipped than the infantry. Armor and helmets were common, while weapons consisted of a large bladed spear and a long slashing sword for close combat. Shields could be round, hexagonal, or oval, but the most common was a regular oval body shield with the top and bottom shorn off. Unlike other horseman, the Celts were not afraid to leap off their mount to fight on foot then climb into the saddle again when possible.</History>
     <Icon>units/cart_cavalry_swordsman_2.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_cavalry_swordsman_gaul_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_cavalry_swordsman_iber_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_cavalry_swordsman_iber_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_cavalry_swordsman_iber_b.xml	(copie de travail)
@@ -9,11 +9,12 @@
   <Identity>
     <Civ>cart</Civ>
     <SelectionGroupName>units/cart_cavalry_swordsman_iber_b</SelectionGroupName>
     <GenericName>Iberian Heavy Cavalry</GenericName>
     <SpecificName>Ḥayyāl Ḥerev Raḫūv</SpecificName>
-    <Classes datatype="tokens">Iberian Mercenary</Classes>
+    <Classes datatype="tokens">Iberian</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>Along with the Gauls, Iberians formed the Carthaginian heavy cavalry, closing with their opponents at every opportunity. Armed with long-bladed spears and short curved sabers known as falcata, the Iberians were no strangers to fighting on horseback. On many occasions they routed opposing cavalry but usually did not pursue them, preferring to remain close to the main army.</History>
     <Icon>units/cart_cavalry_swordsman.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_cavalry_swordsman_iber_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_infantry_archer_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_infantry_archer_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_infantry_archer_b.xml	(copie de travail)
@@ -12,10 +12,11 @@
   <Identity>
     <Civ>cart</Civ>
 	<SelectionGroupName>units/cart_infantry_archer_b</SelectionGroupName>
     <GenericName>Mauritanian Archer</GenericName>
     <SpecificName>Qešet</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>A mercenary archer from North Africa.</History>
     <Icon>units/cart_infantry_archer.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_infantry_archer_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_infantry_javelinist_iber_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_infantry_javelinist_iber_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_infantry_javelinist_iber_b.xml	(copie de travail)
@@ -10,20 +10,21 @@
     </Entities>
   </Builder>
   <Cost>
     <Resources>
       <food>25</food>
-	  <wood>50</wood>
-	  <metal>25</metal>
+      <wood>50</wood>
+      <metal>25</metal>
     </Resources>
   </Cost>
   <Identity>
     <Civ>cart</Civ>
     <SelectionGroupName>units/cart_infantry_javelinist_iber_b</SelectionGroupName>
     <GenericName>Iberian Mercenary Skirmisher</GenericName>
     <SpecificName>Sǝḫīr Kidōn</SpecificName>
-    <Classes datatype="tokens">Iberian Mercenary</Classes>
+    <Classes datatype="tokens">Iberian</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>While Iberians had often served as mercenaries in earlier times, after Carthage's conquest of Spain they were often called up as levies. After the Celts they were considered the most expendable of all the troops in the Carthaginian army, used to dull the force of a charging formation. Armed with a javelin that could have a bundle of burning grass attached at the end for torching buildings, the Iberians could also wear light breastplates called pectorals in addition to their distinctive sinew caps.</History>
     <Icon>units/cart_infantry_javelinist.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_infantry_javelinist_iber_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_infantry_slinger_iber_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_infantry_slinger_iber_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_infantry_slinger_iber_b.xml	(copie de travail)
@@ -10,20 +10,21 @@
     </Entities>
   </Builder>
   <Cost>
     <Resources>
       <food>25</food>
-	  <stone>50</stone>
-	  <metal>25</metal>
+      <stone>50</stone>
+      <metal>25</metal>
     </Resources>
   </Cost>
   <Identity>
     <Civ>cart</Civ>
     <SelectionGroupName>units/cart_infantry_slinger_iber_b</SelectionGroupName>
     <GenericName>Balearic Slinger</GenericName>
     <SpecificName>Qallāʿ Ibušimi</SpecificName>
-    <Classes datatype="tokens">Iberian Mercenary</Classes>
+    <Classes datatype="tokens">Iberian</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>Levied from the Balearic Islands off Spain, these slingers proved to be the greatest the world ever produced, capable of hurling jagged rocks over distances that archers could not match. It was a Balearic slinger that heavily wounded the Roman consul Paullus at the beginning of the bloody battle at Cannae. Stones flung from slings were able to crush and puncture through armor at long ranges, be it iron or bronze.</History>
     <Icon>units/cart_infantry_slinger.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_infantry_slinger_iber_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_infantry_swordsman_gaul_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_infantry_swordsman_gaul_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_infantry_swordsman_gaul_b.xml	(copie de travail)
@@ -10,19 +10,20 @@
     </Entities>
   </Builder>
   <Cost>
     <Resources>
       <food>25</food>
-	  <metal>50</metal>
+      <metal>50</metal>
     </Resources>
   </Cost>
   <Identity>
     <Civ>cart</Civ>
     <SelectionGroupName>units/cart_infantry_swordsman_gaul_b</SelectionGroupName>
     <GenericName>Gallic Mercenary Swordsman</GenericName>
     <SpecificName>Seḫīr Ḥerev</SpecificName>
-    <Classes datatype="tokens">Celt Mercenary</Classes>
+    <Classes datatype="tokens">Celt</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>Hannibal hired Celtic mercenaries when he invaded Italy in 218 BC, recruited from the Gallic tribesmen in the northern third of the country. Fierce and physically imposing thanks to their height the Celtic soldiers attacked their opponents with swords and spears in a solid wave. They were capable of changing formations and despite their usual lack of body armor they were quite capable of hacking down their opponents.</History>
     <Icon>units/cart_infantry_swordsman.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_infantry_swordsman_gaul_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/cart_infantry_swordsman_ital_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/cart_infantry_swordsman_ital_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/cart_infantry_swordsman_ital_b.xml	(copie de travail)
@@ -10,19 +10,20 @@
     </Entities>
   </Builder>
   <Cost>
     <Resources>
       <food>25</food>
-	  <metal>50</metal>
+      <metal>50</metal>
     </Resources>
   </Cost>
   <Identity>
     <Civ>cart</Civ>
     <SelectionGroupName>units/cart_infantry_swordsman_ital_b</SelectionGroupName>
     <GenericName>Samnite Swordsman</GenericName>
     <SpecificName>Seḫīr Romaḥ</SpecificName>
-    <Classes datatype="tokens">Italian Mercenary</Classes>
+    <Classes datatype="tokens">Italian</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>TBD.</History>
     <Icon>units/cart_infantry_swordsman_2.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/cart_infantry_swordsman_ital_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/mace_infantry_archer_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/mace_infantry_archer_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/mace_infantry_archer_b.xml	(copie de travail)
@@ -17,10 +17,11 @@
     <Civ>mace</Civ>
     <Lang>greek</Lang>
 	<SelectionGroupName>units/mace_infantry_archer_b</SelectionGroupName>
     <GenericName>Cretan Mercenary Archer</GenericName>
     <SpecificName>Toxótēs Krētikós</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>Mercenary archers from the big island of Crete. They were widely regarded as the best archers in all of Hellas and had a long tradition of hiring themselves out to Hellenic states such as Athens for use aboard Triremes naval vessels. Alexander hired them to accompany him on his world conquest march and while in his service they dueled admirably with the greatly feared eastern archers.</History>
     <Icon>units/hele_infantry_archer.png</Icon>
     <RequiredTechnology>phase_town</RequiredTechnology>
   </Identity>
   <Promotion>
Index: binaries/data/mods/public/simulation/templates/units/ptol_cavalry_javelinist_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/ptol_cavalry_javelinist_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/ptol_cavalry_javelinist_merc_b.xml	(copie de travail)
@@ -10,10 +10,11 @@
   <Identity>
     <Civ>ptol</Civ>
     <SelectionGroupName>units/ptol_cavalry_javelinist_merc_b</SelectionGroupName>
     <GenericName>Tarantine Settler Cavalry</GenericName>
     <SpecificName>Hippeús Tarantînos</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>?</History>
     <Icon>units/mace_cavalry_javelinist.png</Icon>
     <RequiredTechnology>phase_town</RequiredTechnology>
   </Identity>
   <Promotion>
Index: binaries/data/mods/public/simulation/templates/units/ptol_cavalry_spearman_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/ptol_cavalry_spearman_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/ptol_cavalry_spearman_merc_b.xml	(copie de travail)
@@ -3,10 +3,11 @@
   <Identity>
     <Civ>ptol</Civ>
     <SelectionGroupName>units/ptol_cavalry_spearman_merc_b</SelectionGroupName>
     <GenericName>Macedonian Settler Cavalry</GenericName>
     <SpecificName>Hippeús Makedonikós</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>?</History>
     <Icon>units/ptol_cavalry_spearman.png</Icon>
     <RequiredTechnology>phase_town</RequiredTechnology>
   </Identity>
   <Promotion>
Index: binaries/data/mods/public/simulation/templates/units/ptol_infantry_spearman_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/ptol_infantry_spearman_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/ptol_infantry_spearman_merc_b.xml	(copie de travail)
@@ -18,10 +18,11 @@
   <Identity>
     <Civ>ptol</Civ>
     <SelectionGroupName>units/ptol_infantry_spearman_merc_b</SelectionGroupName>
 	<GenericName>Mercenary Thureos Spearman</GenericName>
     <SpecificName>Thureophóros Misthophóros</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>The thureophoroi (singular: thureophoros) was a type of infantry soldier, common in the 3rd to 1st century BC, who carried a large oval shield called a thureos which had a type of metal strip boss and a central spine. They were armed with a long thrusting spear, javelins and a sword. They also usually wore an iron or bronze Macedonian helmet. The thureos was probably originally an adapted form of a Celtic shield. Thracian and Illyrian infantry probably adopted the shield before the Greeks. However it has been suggested that the thureos was brought to Greece after Pyrrhus of Epirus' campaigns in Italy, as his Oscan allies and Roman enemies used the scutum. Thureophoroi were a 3rd century development on the Peltast and wore no body armor, but did wear sturdy leather boots for quick movement. Thureophoroi could skirmish, as well as fight in a phalanx when necessary. They were often stationed on the flanks of the traditional pike phalanx as a flexible link between the heavier pikemen and the cavalry wings.</History>
     <Icon>units/sele_infantry_spearman_2.png</Icon>
   </Identity>
   <Promotion>
     <Entity>units/ptol_infantry_spearman_merc_a</Entity>
Index: binaries/data/mods/public/simulation/templates/units/ptol_infantry_swordsman_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/ptol_infantry_swordsman_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/ptol_infantry_swordsman_merc_b.xml	(copie de travail)
@@ -17,11 +17,12 @@
   <Identity>
     <Civ>ptol</Civ>
     <SelectionGroupName>units/ptol_infantry_swordsman_merc_b</SelectionGroupName>
     <GenericName>Gallic Mercenary Swordsman</GenericName>
     <SpecificName>Gallikós Mistophorós</SpecificName>
-    <Classes datatype="tokens">Celt Mercenary</Classes>
+    <Classes datatype="tokens">Celt</Classes>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History></History>
     <Icon>units/cart_infantry_swordsman.png</Icon>
     <RequiredTechnology>phase_town</RequiredTechnology>
   </Identity>
   <Promotion>
Index: binaries/data/mods/public/simulation/templates/units/samnite_skirmisher.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/samnite_skirmisher.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/samnite_skirmisher.xml	(copie de travail)
@@ -2,12 +2,12 @@
 <Entity parent="template_unit_champion_infantry_javelinist">
   <Identity>
     <Civ>gaia</Civ>
     <GenericName>Samnite Skirmisher</GenericName>
     <SpecificName>(Samnite Skirmisher)</SpecificName>
-    <Tooltip>Mercenary skirmisher.
-Bonus vs. Archers and Spearmen.</Tooltip>
+    <Tooltip>Mercenary skirmisher. Bonus vs. Archers and Spearmen.</Tooltip>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>The Samnites were an aboriginal people of Southern and Central Italy. They were fierce warriors and frequently rebelled against Roman rule.</History>
     <Icon>units/samnite_skirmisher.png</Icon>
   </Identity>
   <VisualActor>
     <Actor>units/carthaginians/samnite_skirmisher.xml</Actor>
Index: binaries/data/mods/public/simulation/templates/units/samnite_spearman.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/samnite_spearman.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/samnite_spearman.xml	(copie de travail)
@@ -5,10 +5,11 @@
     <GenericName>Samnite Spearman</GenericName>
     <SpecificName>(Samnite Spearman)</SpecificName>
     <Tooltip>Mercenary spearman.
 Bonus vs. All Cavalry Units.</Tooltip>
     <History>The Samnites were an aboriginal people of Southern and Central Italy. They were fierce warriors and frequently rebelled against Roman rule.</History>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <Icon>units/samnite_spearman.png</Icon>
   </Identity>
   <VisualActor>
     <Actor>units/carthaginians/samnite_spearman.xml</Actor>
   </VisualActor>
Index: binaries/data/mods/public/simulation/templates/units/sele_cavalry_spearman_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/sele_cavalry_spearman_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/sele_cavalry_spearman_merc_b.xml	(copie de travail)
@@ -4,10 +4,11 @@
     <Civ>sele</Civ>
     <Lang>greek</Lang>
     <SelectionGroupName>units/sele_cavalry_spearman_merc_b</SelectionGroupName>
     <GenericName>Companion Cavalry</GenericName>
     <SpecificName>Hippos Hetairike</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>There were two guard cavalry regiments, each 1,000 strong. These were the Agema (the 'Guards') and the Hetairoi ('Companions'). The Hetairoi were recruited from the younger generation of military settlers and acted as the standing guard cavalry unit of the army, serving in peace and in war. However it seems that writers referred to them by several names other than just the 'companions'; the basilike ile ('royal squadron' or 'regia ala' according to Livy), and the hippos hetairike ('horse companions'). Their full title may well have been the 'royal ala of the companions'.</History>
     <RequiredTechnology>phase_town</RequiredTechnology>
     <Icon>units/mace_cavalry_spearman.png</Icon>
   </Identity>
   <Promotion>
Index: binaries/data/mods/public/simulation/templates/units/sele_infantry_archer_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/sele_infantry_archer_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/sele_infantry_archer_merc_b.xml	(copie de travail)
@@ -11,10 +11,11 @@
     <Civ>sele</Civ>
     <Lang>greek</Lang>
 	<SelectionGroupName>units/sele_infantry_archer_merc_b</SelectionGroupName>
     <GenericName>Syrian Archer</GenericName>
     <SpecificName>Toxótēs Syrías</SpecificName>
+    <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
     <History>Syrian archers mix the archery traditions of Crete with those of the East. Large numbers of Cretan colonists and mercenaries were settled within the borders of the Seleucid Empire. In return for lands, the colonists pledged themselves and their offspring to serve in the armies of the Seleucid king when called by him.</History>
     <Icon>units/hele_infantry_archer.png</Icon>
     <RequiredTechnology>phase_town</RequiredTechnology>
   </Identity>
   <Promotion>
Index: binaries/data/mods/public/simulation/templates/units/sele_infantry_swordsman_merc_b.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/units/sele_infantry_swordsman_merc_b.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/units/sele_infantry_swordsman_merc_b.xml	(copie de travail)
@@ -12,12 +12,12 @@
     <Lang>greek</Lang>
     <SelectionGroupName>units/sele_infantry_swordsman_merc_b</SelectionGroupName>
     <GenericName>Thracian Mercenary Swordsman</GenericName>
     <SpecificName>Rhomphaiaphoros Thrakikós</SpecificName>
     <Icon>units/sele_infantry_swordsman.png</Icon>
-    <History>Thracian tribesmen who wield the fearsome rhomphaia polearm weapon in combat. They were ubiquitous mercenary swordsmen and skirmishers throughout Hellenistic times, sometimes even serving in two opposing armies.</History>
     <VisibleClasses datatype="tokens">Mercenary</VisibleClasses>
+    <History>Thracian tribesmen who wield the fearsome rhomphaia polearm weapon in combat. They were ubiquitous mercenary swordsmen and skirmishers throughout Hellenistic times, sometimes even serving in two opposing armies.</History>
     <RequiredTechnology>phase_town</RequiredTechnology>
   </Identity>
   <Promotion>
     <Entity>units/sele_infantry_swordsman_merc_a</Entity>
   </Promotion>