Index: binaries/data/mods/public/simulation/data/technologies/advanced_unit_bonus.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/advanced_unit_bonus.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/advanced_unit_bonus.json	(working copy)
@@ -1,5 +1,7 @@
 {
 	"autoResearch": true,
+	"icon": "upgrade_advanced.png",
+	"tooltip": "Units promoted to the advanced class gain a lot of quality: 20% extra health, 1 extra armour level of every type, 20% extra attack for melee units, 4m extra range and 5% better precision for ranged units, faster movement speeds and extra heal speed and range for healers.",
 	"modifications": [
 		{"value": "Health/Max",             "multiply":    1.2                       },
 		{"value": "Armour/Hack",            "add":         1                         },
@@ -10,8 +12,8 @@
 		{"value": "UnitMotion/WalkSpeed",   "add":         1,   "affects": "Cavalry" },
 		{"value": "Attack/Ranged/MaxRange", "add":         4,   "affects": "Ranged"  },
 		{"value": "Attack/Ranged/Spread",   "multiply":    0.95,"affects": "Ranged"  },
-		{"value": "Attack/Melee/Hack",      "multiply":    1.2,  "affects": "Melee"  },
-		{"value": "Attack/Melee/Pierce",    "multiply":    1.2,  "affects": "Melee"  },
+		{"value": "Attack/Melee/Hack",      "multiply":    1.2, "affects": "Melee"   },
+		{"value": "Attack/Melee/Pierce",    "multiply":    1.2, "affects": "Melee"   },
 		{"value": "Heal/Range",             "add":         4,   "affects": "Healer"  },
 		{"value": "Heal/HP",                "add":         5,   "affects": "Healer"  }
 	],
Index: binaries/data/mods/public/simulation/data/technologies/carthaginians/civbonus_triple_walls.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/carthaginians/civbonus_triple_walls.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/carthaginians/civbonus_triple_walls.json	(working copy)
@@ -1,8 +1,10 @@
 {
 	"genericName": "Triple Walls",
 	"autoResearch": true,
-	"description": "Carthaginians built their city walls in three concentric circuits. These walls were never breached. Even when the city was taken by the Romans, it was via the city's harbor, not by storming its walls. Consequently, Carthaginian walls, gates, and wall towers have 3x the health of a standard wall, but also cost twice as much and take twice as long to build.",
+	"description": "Carthaginians built their city walls in three concentric circuits. These walls were never breached. Even when the city was taken by the Romans, it was via the city's harbor, not by storming its walls.",
 	"requirements": {"civ": "cart"},
+	"icon": "wall.png",
+	"tooltip": "Carthaginian walls, gates, and wall towers have 3x the health of a standard wall, but also cost twice as much and take twice as long to build.",
 	"modifications": [
 		{"value": "Health/Max", "multiply": 3.0},
 		{"value": "Cost/BuildTime", "multiply": 2.0},
@@ -9,4 +11,4 @@
 		{"value": "Cost/Resources/stone", "multiply": 2.0}
 	],
 	"affects": ["StoneWall"]
-}
\ No newline at end of file
+}
Index: binaries/data/mods/public/simulation/data/technologies/celts/civbonus_celts_wooden_struct.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/celts/civbonus_celts_wooden_struct.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/celts/civbonus_celts_wooden_struct.json	(working copy)
@@ -1,8 +1,10 @@
 {
 	"genericName": "Wooden Construction",
 	"autoResearch": true,
-	"description": "Celtic structures were mostly made of wood with rubble foundations. Consequently, their structures have less health than other cultures do, but they also construct faster.",
+	"description": "Celtic structures were mostly made of wood with rubble foundations.",
 	"requirements": {"any": [{"civ": "brit"},{"civ": "gaul"}]},
+	"icon": "wooden_buildings.png",
+	"tooltip": "Celtic buildings have 20% less health, but are also 20% cheaper and faster to construct.",
 	"modifications": [
 		{"value": "Health/Max", "multiply": 0.8},
 		{"value": "Capturable/CapturePoints", "multiply": 0.8},
Index: binaries/data/mods/public/simulation/data/technologies/elite_unit_bonus.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/elite_unit_bonus.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/elite_unit_bonus.json	(working copy)
@@ -1,5 +1,7 @@
 {
 	"autoResearch": true,
+	"icon": "upgrade_elite.png",
+	"tooltip": "Units trained to the elite class gain a lot of quality: 20% extra health, 1 extra armour level of every type, 20% extra attack for melee units, extra range and better precision for ranged units, faster movement speeds and extra heal speed and range for healers.",
 	"modifications": [
 		{"value": "Health/Max",             "multiply":    1.2                       },
 		{"value": "Armour/Hack",            "add":         1                         },
Index: binaries/data/mods/public/simulation/data/technologies/hellenes/civbonus_hellenic_architecture.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/hellenes/civbonus_hellenic_architecture.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/hellenes/civbonus_hellenic_architecture.json	(working copy)
@@ -3,6 +3,8 @@
 	"autoResearch": true,
 	"description": "The Greeks used stone construction from early Mycenaean times.",
 	"requirements": {"any": [{"civ": "athen"},{"civ": "mace"},{"civ": "spart"}]},
+	"icon": "ionic_column.png",
+	"tooltip": "All structures have 10% more health and capture points, but also take 10% longer to build.",
 	"modifications": [
 		{"value": "Health/Max", "multiply": 1.1},
 		{"value": "Capturable/CapturePoints", "multiply": 1.1},
Index: binaries/data/mods/public/simulation/data/technologies/hellenes/civpenalty_spart_popcap.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/hellenes/civpenalty_spart_popcap.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/hellenes/civpenalty_spart_popcap.json	(working copy)
@@ -3,5 +3,7 @@
 	"autoResearch": true,
 	"description": "The Spartans did not have the largest army in the world, but they did have the best army in the world for their time. What they didn't have in quantity, they made up with quality. It was said that Sparta did not need strong city walls, for its men were its walls.",
 	"requirements": {"civ": "spart"},
+	"icon": "population.png",
+	"tooltip": "Spartans have 10% less maximum population",
 	"modifications": [{"value": "Player/MaxPopulation", "multiply": 0.9}]
-}
\ No newline at end of file
+}
Index: binaries/data/mods/public/simulation/data/technologies/hellenes/teambonus_athen_delian_league.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/hellenes/teambonus_athen_delian_league.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/hellenes/teambonus_athen_delian_league.json	(working copy)
@@ -3,6 +3,8 @@
 	"autoResearch": true,
 	"description": "Shortly after the great naval victories at Salamis and Mycale, the Greek city-states instituted the so-called Delian League in 478 BC, whose purpose was to push the Persians out of the Aegean region. The allied states contributed ships and money, while the Athenians offered their entire navy.",
 	"requirements": {"civ": "athen"},
+	"icon": "ship_buildtime.png",
+	"tooltip": "Athenian ships take 25% less time to construct.",
 	"modifications": [{"value": "Cost/BuildTime", "multiply": 0.75}],
 	"affects": ["Warship"]
-}
\ No newline at end of file
+}
Index: binaries/data/mods/public/simulation/data/technologies/mauryans/civbonus_maur_popcap.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/mauryans/civbonus_maur_popcap.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/mauryans/civbonus_maur_popcap.json	(working copy)
@@ -6,5 +6,7 @@
 	"autoResearch": true,
 	"description": "The Mauryan Empire encompassed dozens of formerly independent kingdoms over an area of 5 million square kilometers, with a population of close to 60 million people. The Mauryan regents held the title Emperor of Emperors and commanded a standing army of 600,000 infantry, 9000 elephants, 8000 chariots, and 30,000 cavalry, making it arguably the largest army of its time.",
 	"requirements": {"civ": "maur"},
+	"icon": "population.png",
+	"tooltip": "Mauryans have a 10% higher maximum population limit.",
 	"modifications": [{"value": "Player/MaxPopulation", "multiply": 1.1}]
-}
\ No newline at end of file
+}
Index: binaries/data/mods/public/simulation/data/technologies/mauryans/wooden_walls.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/mauryans/wooden_walls.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/mauryans/wooden_walls.json	(working copy)
@@ -1,11 +1,13 @@
 {
 	"genericName": "Wooden Walls",
 	"autoResearch": true,
-	"description": "The Mauryans built their city walls out of wood, an abundant natural resource in India. Consequently, Mauryan city walls have -20% health and -20% build time.",
+	"description": "The Mauryans built their city walls out of wood, an abundant natural resource in India.",
 	"requirements": {"civ": "maur"},
+	"icon": "wooden_walls.png",
+	"tooltip": "Mauryan city walls have 20% less health and 20% less build time.",
 	"modifications": [
 		{"value": "Health/Max", "multiply": 0.8},
 		{"value": "Cost/BuildTime", "multiply": 0.8}
 	],
 	"affects": ["StoneWall"]
-}
\ No newline at end of file
+}
Index: binaries/data/mods/public/simulation/data/technologies/persians/civbonus_pers_popcap.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/persians/civbonus_pers_popcap.json	(revision 18087)
+++ binaries/data/mods/public/simulation/data/technologies/persians/civbonus_pers_popcap.json	(working copy)
@@ -3,5 +3,7 @@
 	"autoResearch": true,
 	"description": "The Persians could and did levy a large number of infantry during wartime due to the sheer size of the Achaemenid Empire and the way in which it was set-up. In general the Persian infantry was well trained and fought with great tenacity. However while this was true the infantry were poor hand-to-hand, close combat fighters. Also, with the exception of the elite regiments, the Persian infantry was not a standing professional force.",
 	"requirements": {"civ": "pers"},
+	"icon": "population.png",
+	"tooltip": "Persians have a 10% higher maximum population limit.",
 	"modifications": [{"value": "Player/MaxPopulation", "multiply": 1.1}]
-}
\ No newline at end of file
+}