Index: binaries/data/mods/public/simulation/components/Player.js
===================================================================
--- binaries/data/mods/public/simulation/components/Player.js	(révision 17867)
+++ binaries/data/mods/public/simulation/components/Player.js	(copie de travail)
@@ -142,11 +142,11 @@ Player.prototype.SetMaxPopulation = func
 	this.maxPop = max;
 };
 
 Player.prototype.GetMaxPopulation = function()
 {
-	return Math.round(ApplyValueModificationsToPlayer("Player/MaxPopulation", this.maxPop, this.entity, this.playerID));
+	return Math.round(ApplyValueModificationsToPlayer("Player/MaxPopulation", this.maxPop, this.entity));
 };
 
 Player.prototype.SetGatherRateMultiplier = function(value)
 {
 	this.gatherRateMultiplier = value;
Index: binaries/data/mods/public/simulation/data/technologies/pop_wonder.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/pop_wonder.json	(révision 17867)
+++ binaries/data/mods/public/simulation/data/technologies/pop_wonder.json	(copie de travail)
@@ -8,15 +8,14 @@
 		"ptol": "Peristyle",
 		"rome": "Peristyle",
 		"pers": "Paradise"
 	},
 	"description": "The wonder attracts many more people to your civilization.",
-	"cost": { "food": 2000, "wood": 3000, "stone": 500, "metal": 500 },
+	"cost": { "food": 3000, "wood": 3000, "stone": 500, "metal": 500 },
 	"requirements": { "tech": "phase_city" },
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "special_treasure.png",
 	"researchTime": 40,
-	"tooltip": "Increase the population bonus of the wonder by 40.",
-	"modifications": [{ "value": "Auras/Aura1/Modifications/Player/MaxPopulation/Add", "add": 40 }],
-	"affects": ["Wonder"],
+	"tooltip": "+50 maximum population cap.",
+	"modifications": [{ "value": "Player/MaxPopulation", "add": 50 }],
 	"soundComplete": "interface/alarm/alarm_upgradearmory.xml"
 }
Index: binaries/data/mods/public/simulation/helpers/ValueModification.js
===================================================================
--- binaries/data/mods/public/simulation/helpers/ValueModification.js	(révision 17867)
+++ binaries/data/mods/public/simulation/helpers/ValueModification.js	(copie de travail)
@@ -11,18 +11,13 @@ function ApplyValueModificationsToEntity
 	if (!cmpAuraManager)
 		return value;
 	return cmpAuraManager.ApplyModifications(tech_type, value, entity);
 }
 
-function ApplyValueModificationsToPlayer(tech_type, current_value, playerEntity, playerID)
+function ApplyValueModificationsToPlayer(tech_type, current_value, playerEntity)
 {
-	let cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
-	if (!cmpTemplateManager)
-		return current_value;
-	let entityTemplateName = cmpTemplateManager.GetCurrentTemplateName(playerEntity);
-	let entityTemplate = cmpTemplateManager.GetTemplate(entityTemplateName);
-	return ApplyValueModificationsToTemplate(tech_type, current_value, playerID, entityTemplate);
+	return ApplyValueModificationsToEntity(tech_type, current_value, playerEntity);
 }
 
 function ApplyValueModificationsToTemplate(tech_type, current_value, playerID, template)
 {
 	let value = current_value;
@@ -30,11 +25,11 @@ function ApplyValueModificationsToTempla
 	if (cmpTechnologyManager)
 		value = cmpTechnologyManager.ApplyModificationsTemplate(tech_type, current_value, template);
 
 	let cmpAuraManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_AuraManager); 
 	if (!cmpAuraManager)
-		return value; 
+		return value;
 	return cmpAuraManager.ApplyTemplateModifications(tech_type, value, playerID, template);
 }
 
 Engine.RegisterGlobal("ApplyValueModificationsToEntity", ApplyValueModificationsToEntity);
 Engine.RegisterGlobal("ApplyValueModificationsToPlayer", ApplyValueModificationsToPlayer);
Index: binaries/data/mods/public/simulation/templates/special/player.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/special/player.xml	(révision 17867)
+++ binaries/data/mods/public/simulation/templates/special/player.xml	(copie de travail)
@@ -46,15 +46,10 @@
       <CivilCentre>
         <RequiredTechs datatype="tokens">phase_town</RequiredTechs>
       </CivilCentre>
     </LimitRemovers>
   </EntityLimits>
-  <Identity>
-    <Civ></Civ>
-    <GenericName>Player</GenericName>
-    <Classes datatype="tokens">Player</Classes>
-  </Identity>
   <Player>
     <SharedLosTech>unlock_shared_los</SharedLosTech>
   </Player>
   <StatisticsTracker/>
   <TechnologyManager/>
Index: binaries/data/mods/public/simulation/templates/template_structure_wonder.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_structure_wonder.xml	(révision 17867)
+++ binaries/data/mods/public/simulation/templates/template_structure_wonder.xml	(copie de travail)
@@ -8,32 +8,21 @@
       <Hack>2</Hack>
       <Pierce>10</Pierce>
       <Crush>2</Crush>
     </Foundation>
   </Armour>
-  <Auras>
-    <Aura1>
-      <Type>global</Type>
-      <Affects>Player</Affects>
-      <Modifications>
-        <Player.MaxPopulation> <Add>10</Add> </Player.MaxPopulation>
-      </Modifications>
-      <AuraName>Wonder Aura</AuraName>
-      <AuraDescription>+10 maximum population cap.</AuraDescription>
-     </Aura1>
-  </Auras>
   <BuildRestrictions>
     <Category>Wonder</Category>
   </BuildRestrictions>
   <Capturable>
-    <CapturePoints>2000</CapturePoints>
+    <CapturePoints>1500</CapturePoints>
     <RegenRate>5.0</RegenRate>
   </Capturable>
   <Cost>
     <BuildTime>1000</BuildTime>
     <Resources>
-      <food>1000</food>
+      <food>0</food>
       <wood>1000</wood>
       <stone>1000</stone>
       <metal>1000</metal>
     </Resources>
   </Cost>